program opiela19;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this },
  crt;

{$R *.res}

type ukazovatel=^zaznam;
     zaznam=record
       hodnota:integer;
       dalsi:ukazovatel;
     end;

var start:ukazovatel;
    z:char;
    i,n,x:integer;

procedure PridajNaZaciatok(hodnota:integer);
var p:ukazovatel;
begin
  new(p);
  p^.hodnota:=hodnota;
  p^.dalsi:=start;
  start:=p;
end;

procedure PridajNaKoniec(hodnota:integer);
var p,q:ukazovatel;
begin
  new(p); {dispose(p) - zrusi ukazovatel}
  p^.hodnota:=hodnota;
  p^.dalsi:=nil;
  if start=nil
     then start:=p
     else begin
            q:=start;
            while q^.dalsi<>nil do
              q:=q^.dalsi;
            q^.dalsi:=p;
          end;
end;

procedure OdoberZaciatok;
begin
  if start=nil
     then Writeln('Zoznam je prazdny.')
     else begin
            Writeln('Odobrana hodnota ',start^.hodnota);
            start:=start^.dalsi;
          end;
end;

procedure OdoberKoniec;
var p:ukazovatel;
begin
  if start=nil
     then Writeln('Zoznam je prazdny.')
     else if start^.dalsi=nil
             then begin
                    Writeln('Odobrana hodnota ',start^.hodnota);
                    start:=nil;
                  end
             else begin
                    p:=start;
                    while p^.dalsi^.dalsi<>nil do
                      p:=p^.dalsi;
                    Writeln('Odobrana hodnota ',p^.dalsi^.hodnota);
                    p^.dalsi:=nil;
                  end;
end;

procedure Odober(x:integer);
var p:ukazovatel;
    zmeny:boolean;
begin
  p:=start;
  zmeny:=false;
  if start=nil
     then Write('Zoznam je prazdny. ')
     else begin
            if start^.hodnota=x
               then begin
                      start:=start^.dalsi;
                      Writeln('Hodnota ',x,' bola odstranena.');
                      zmeny:=true;
                    end;
            while (zmeny=false) and (p^.dalsi^.dalsi<>nil) do
              begin
                if p^.dalsi^.hodnota=x
                   then begin
                          p^.dalsi:=p^.dalsi^.dalsi;
                          Writeln('Hodnota ',x,' bola odstranena.');
                          zmeny:=true;
                        end
                   else p:=p^.dalsi;
              end;
            if (zmeny=false) and (p^.dalsi^.hodnota=x)
               then begin
                      p^.dalsi:=nil;
                      Writeln('Hodnota ',x,' bola odstranena.');
                      zmeny:=true;
                    end;
          end;
  if not zmeny
     then Writeln('Hodnota ',x,' sa v zozname nenachadza.');
end;

procedure VypisZoznam;
var p:ukazovatel;
begin
  p:=start;
  while p<>nil do
    begin
      Write(p^.hodnota,' ');
      p:=p^.dalsi;
    end;
end;

procedure menu;
begin
  Writeln('Vitajte v programe pre pracu s dynamickymi datovymi strukturami.');
  Writeln('a) Vypis cely zoznam.');
  Writeln('b) Pridaj na zaciatok.');
  Writeln('c) Pridaj na koniec.');
  Writeln('d) Odober zo zaciatku.');
  Writeln('e) Odober z konca.');
  Writeln('f) Odstranenie konkretnej hodnoty. (Odstranuje po jednom)');
  Writeln('g) Zmaz cely zoznam.');
  Writeln('q) Koniec.');
  Writeln('Zadajte pismeno ulohy, ktoru mam vykonat:');
  Writeln('-----------------------------------------');
end;

begin
  start:=nil;
  repeat
    ClrScr;
    menu;
    z:=readkey;
    case z of
    'a': begin
           if start=nil
              then Writeln('Zoznam je prazdny.')
              else begin
                     Writeln('Zoznam:');
                     VypisZoznam;
                   end;
           Readln;
         end;
    'b': begin
           Write('Kolko prvkov chcete pridat? ');
           Readln(n);
           for i:=1 to n do
            begin
             Write('Zadajte cislo, ktore chcete pridat na zaciatok: ');
             Readln(x);
             PridajNaZaciatok(x);
            end;
           Writeln('Pridane na zaciatok.');
           Readln;
         end;
    'c': begin
           Write('Kolko prvkov chcete pridat? ');
           Readln(n);
           for i:=1 to n do
            begin
             Write('Zadajte cislo, ktore chcete pridat na koniec: ');
             Readln(x);
             PridajNaKoniec(x);
            end;
           Writeln('Pridane na koniec.');
           Readln;
         end;
    'd': begin
           Write('Kolko prvkov chcete odobrat? ');
           Readln(n);
           for i:=1 to n do
             begin
               if start=nil
                  then begin
                         Writeln('Zoznam je prazdny.');
                         break;
                       end;
               OdoberZaciatok;
             end;
           Readln;
         end;
    'e': begin
           Write('Kolko prvkov chcete odobrat? ');
           Readln(n);
           for i:=1 to n do
             begin
               if start=nil
                  then begin
                         Writeln('Zoznam je prazdny.');
                         break;
                       end;
               OdoberKoniec;
             end;
           Readln;
         end;
    'f': begin
           Write('Aku hodnotu ma prvok, ktory chcete odstranit? ');
           Readln(x);
           Odober(x);
           Readln;
         end;
    'g': begin
           start:=nil;
           Writeln('Zoznam je zmazany.');
           Readln;
         end;
    end;
  until z='q';
end.

